package game;

import game.exceptions.AdversaryLoggedOffException;
import game.exceptions.GameResult;
import game.exceptions.LoginException;
import game.exceptions.RegisterException;
import game.objects.Message;

import java.rmi.NotBoundException;
import java.rmi.RemoteException;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 17/Jan/2007
 * Time: 1:38:24
 * To change this template use File | Settings | File Templates.
 */
public interface AbstractPlayer
{
	void setServer(String server);

	void setName(String name);

	void setPassword(String password);

	void login() throws NotBoundException, LoginException, RemoteException;

	void register() throws NotBoundException, RegisterException, RemoteException;

	void logout() throws RemoteException;

	void gameChat(Message message) throws RemoteException, AdversaryLoggedOffException;

	void mainChat(Message message) throws RemoteException;

	void invite(String invitee) throws RemoteException, AdversaryLoggedOffException;

	void answerInvitation(String inviter, boolean accept) throws RemoteException, AdversaryLoggedOffException;

	void drop(String adversaryName, int columnIndex) throws RemoteException, AdversaryLoggedOffException;

	void setPlayerName(String playerName);

	void endGame(GameResult gameResult) throws RemoteException;
}
