package game.objects;

import game.exceptions.GameResult;

import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 11/Dez/2006
 * Time: 7:45:20
 * To change this template use File | Settings | File Templates.
 */
public class AdversaryInfo
{
	private Vector<Message> gameChat;
	private GameBoard gameBoard;

	public AdversaryStatus status;
	private boolean myTurn;
	private GameResult gameResult;
	private String name;
	private String channel;

	public AdversaryInfo(LoggedPlayer loggedPlayer)
	{
		this.name = loggedPlayer.getPlayerName();
		this.channel = loggedPlayer.getChannel();
		gameChat = new Vector<Message>();
		status = AdversaryStatus.NOT_PLAYING_WITH_ME;
	}

	public Vector<Message> getGameChat()
	{
		return gameChat;
	}

	public String getName()
	{
		return name;
	}

	public String toString()
	{
		return "adversaryName " + name + ": " + super.toString();	//To change body of overridden methods use File | Settings | File Templates.
	}

	public void drop(boolean me, int columnIndex) throws GameResult
	{
		try
		{
			gameBoard.drop(me, columnIndex);
		}
		catch (GameResult gameResult)
		{
			this.gameResult = gameResult;
			status = AdversaryStatus.NOT_PLAYING_WITH_ME;
			throw gameResult;
		}
		myTurn = !me;
	}

	public boolean isMyTurn()
	{
		return myTurn; 
	}

	public void startGame(boolean myTurn)
	{
		this.myTurn = myTurn;
		gameBoard = new GameBoard(name, 6, 7);
	}

	public GameBoard getGameBoard()
	{
		return gameBoard;
	}

	public boolean isFull(int columnIndex)
	{
		return gameBoard.isFull(columnIndex);
	}

	public GameResult getGameResult()
	{
		return gameResult;
	}

	public void setGameResult(GameResult gameResult)
	{
		this.gameResult = gameResult;
	}

	public String getChannel()
	{
		return channel;
	}

	public String getTitle()
	{
		return name + ":" + channel + " (" + status + ")";
	}
}
