package game.objects;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 10/Jan/2007
 * Time: 0:14:36
 * To change this template use File | Settings | File Templates.
 */
public class Column
{
	private int rowCount;
	private int diskCount = 0;
	private Cell cells[];

	public Column(int rowCount)
	{
		this.rowCount = rowCount;
		cells = new Cell[rowCount];
		for (int i = 0; i < cells.length; i++)
			cells[i] = new Cell();
	}

	public int getRowCount()
	{
		return rowCount;
	}

	public int getDiskCount()
	{
		return diskCount;
	}

	public String toString()
	{
		String string = "";

		for(Cell cell : cells)
			string += ", " + cell;

		return "{" + string.substring(2) + "}";
	}

	public void drop(boolean me)
	{
		if (diskCount < rowCount)
			cells[diskCount++].setDisk(me);
	}

	public boolean getDisk(int rowIndex)
	{
		return cells[rowIndex].getDisk();
	}

	public boolean isEmpty(int rowIndex)
	{
		return rowIndex >= diskCount;
	}

	public boolean isFull()
	{
		return rowCount == diskCount;
	}
}