package game.objects;

import game.MyElement;
import game.MyColumnType;

import java.io.Serializable;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 10/Dez/2006
 * Time: 7:11:13
 * To change this template use File | Settings | File Templates.
 */
public class Rank implements Serializable, MyElement, Comparable
{
	private String playerName;
	private int points;

	public static Vector<MyColumnType> columns;

	static
	{
		columns = new Vector<MyColumnType>();
		columns.add(new MyColumnType("Player Name", String.class));
		columns.add(new MyColumnType("Points", Integer.class));
	}
	public Rank(String line)
	{
		String[] splits;
		playerName = (splits = line.split(" "))[0];
		points = Integer.parseInt(splits[1]);
	}

	public Rank(String playerName, int points)
	{
		this.playerName = playerName;
		this.points = points;
	}

	public String toString()
	{
		return playerName + " " + points;
	}

	public String getPlayerName()
	{
		return playerName;
	}

	public int getPoints()
	{
		return points;
	}

	public Object getValueAt(int columnIndex)
	{
		switch(columnIndex)
		{
			case 0:
				return playerName;
			case 1:
				return points;
		}
		return null;
	}

	public String getUserName()
	{
		return playerName;
	}

	public int compareTo(Object o)
	{
		return points < ((Rank)o).getPoints() ? -1 : points > ((Rank)o).getPoints() ? 1 : 0;
	}
}
