package game.rmi;

import game.objects.LoggedPlayer;
import game.objects.Message;
import game.objects.Rank;
import game.exceptions.GameResult;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Hashtable;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 10/Dez/2006
 * Time: 6:47:21
 * To change this template use File | Settings | File Templates.
 */
public interface RmiPlayerInterface extends Remote
{
	void beGameChatted(Message message) throws RemoteException;

	void beUpdated(LoggedPlayer[] playersLogged, Hashtable<String, Rank> ranking) throws RemoteException;

	void beMainChatted(Message message) throws RemoteException;

	void beInvited(String inviter) throws RemoteException;

	void seeInvitationAnswered(String invited, boolean accept) throws RemoteException;

	void adversaryDrop(String adversaryName, int columnIndex) throws RemoteException;

	void startGame(String adversaryName, boolean MyTurn) throws RemoteException;

	void endGame(GameResult gameResult) throws RemoteException;
}
