package game.rmi;

import game.exceptions.LoginException;
import game.objects.Message;
import game.exceptions.AdversaryLoggedOffException;
import game.exceptions.GameResult;
import game.exceptions.RegisterException;

import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 9/Dez/2006
 * Time: 22:38:00
 * To change this template use File | Settings | File Templates.
 */
public interface RmiServerInterface extends Remote
{
	void register(RmiPlayerInterface rmiPlayerInterface, String playerName, String password, String channel) throws RegisterException, RemoteException;

	void login(RmiPlayerInterface rmiPlayerInterface, String playerName, String password, String channel) throws LoginException, RemoteException;

	void logout(String playerName) throws RemoteException;

	void gameChat(Message message) throws RemoteException, AdversaryLoggedOffException;

	void mainChat(Message message) throws RemoteException;

	void invite(String inviter, String invitee) throws RemoteException, AdversaryLoggedOffException;

	void answerInvitation(String invited, String inviter, boolean accept) throws RemoteException, AdversaryLoggedOffException;

	void drop(String playerName, String adversaryName, int columnIndex) throws RemoteException, AdversaryLoggedOffException;

	void endGame(String playerName, GameResult gameResult) throws RemoteException;
}
