package gui;

import javax.swing.*;
import java.awt.*;

/**
 * @author Jorge Farinha
 * @author Tiago Santos
 * @version 1.0
 * @date 28-09-2006
 */
public class LoginWindow extends JFrame
{
	private JTextField jTextFieldNomeR;
	private JPasswordField jPasswordField2;
	private JPasswordField jPasswordField3;
	private JPasswordField jPasswordField1;
	private JTextField jTextFieldNomeL;
	private JPanel contentPane;
	private LoginInterface loginInterface;

	public LoginWindow(LoginInterface loginInterface)
	{
		this.loginInterface = loginInterface;
		InicialComponent();
		setVisible(true);
	}

	/**
	 * Janela de login
	 */
	private void InicialComponent()
	{

		JTabbedPane jTabbedPane1 = new JTabbedPane();
		JPanel tabLogin = new JPanel();
		JPanel tabRegistar = new JPanel();
		JLabel jLabelPass1 = new JLabel("Password");
		JLabel jLabelNomeL = new JLabel("Nome");
		JLabel jLabelNomeR = new JLabel("Nome");
		JLabel jLabelPass2 = new JLabel("Password");
		JLabel jLabelPass3 = new JLabel("Password");
		jTextFieldNomeR = new JTextField();
		jPasswordField2 = new JPasswordField();
		jPasswordField3 = new JPasswordField();
		JButton jButtonRegistar = new JButton("Registar");
		jPasswordField1 = new JPasswordField();
		jTextFieldNomeL = new JTextField();
		JButton jButtonLigar = new JButton("Ligar");

		contentPane = (JPanel) this.getContentPane();
		contentPane.setLayout(null);
		contentPane.setBackground(new Color(219, 104, 26));

		jTextFieldNomeL.addKeyListener(new GameListener(12, this, loginInterface));
		jTextFieldNomeR.addKeyListener(new GameListener(13, this, loginInterface));

		jPasswordField1.setEchoChar('*');
		jPasswordField2.setEchoChar('*');
		jPasswordField3.setEchoChar('*');

		jButtonLigar.addActionListener(new GameListener(14, this, loginInterface));
		jButtonRegistar.addActionListener(new GameListener(15, this, loginInterface));

		tabLogin.setBackground(new Color(215, 190, 20));
		tabLogin.setLayout(null);
		addComponent(tabLogin, jLabelNomeL, 15, 10, 70, 35);
		addComponent(tabLogin, jLabelPass1, 15, 55, 70, 35);
		addComponent(tabLogin, jTextFieldNomeL, 85, 19, 100, 25);
		addComponent(tabLogin, jPasswordField1, 85, 52, 100, 25);
		addComponent(tabLogin, jButtonLigar, 235, 52, 115, 25);

		tabRegistar.setLayout(null);
		tabRegistar.setBackground(new Color(236, 81, 46));
		addComponent(tabRegistar, jLabelNomeR, 15, 10, 70, 35);
		addComponent(tabRegistar, jLabelPass2, 15, 55, 70, 35);
		addComponent(tabRegistar, jLabelPass3, 15, 80, 70, 35);
		addComponent(tabRegistar, jTextFieldNomeR, 85, 19, 100, 25);
		addComponent(tabRegistar, jPasswordField2, 85, 52, 100, 25);
		addComponent(tabRegistar, jPasswordField3, 85, 85, 100, 25);
		addComponent(tabRegistar, jButtonRegistar, 235, 85, 115, 25);

		this.setTitle("4 em linha - LogIn");
		this.setLocation(new Point(370, 200));
		this.setSize(new Dimension(380, 180));
		this.setResizable(false);
		this.addWindowListener(new GameListener(16, this, loginInterface));

		jTabbedPane1.addTab("Auth", tabLogin);
		jTabbedPane1.addTab("Registar", tabRegistar);
		addComponent(contentPane, jTabbedPane1, 0, 0, this.getWidth(), this.getHeight());
	}

	/**
	 * Add Component Without a Layout Manager (Absolute Positioning)
	 *
	 * @param container container
	 * @param c		 c
	 * @param x		 x
	 * @param y		 y
	 * @param width	 width
	 * @param height	height
	 */
	private void addComponent(Container container, Component c, int x, int y,
							  int width, int height)
	{
		c.setBounds(x, y, width, height);
		container.add(c);
	}

	/**
	 * sincroniza valores de campos entre os tabs da janela login
	 *
	 * @param field o nome do campo a sincronizar (nome ou servidor)
	 */
	void updateLoginWithRegister(String field)
	{
		if (field.equalsIgnoreCase("nome"))
			jTextFieldNomeL.setText(jTextFieldNomeR.getText());
	}

	/**
	 * sincroniza valores de campos entre os tabs da janela login
	 *
	 * @param field o nome do campo a sincronizar (nome ou servidor)
	 */
	void updateRegisterWithLogin(String field)
	{
		if (field.equalsIgnoreCase("nome"))
			jTextFieldNomeR.setText(jTextFieldNomeL.getText());
	}

	public String getLoginName()
	{
		return jTextFieldNomeL.getText();
	}

	public String getLoginPassword()
	{
		return String.copyValueOf(jPasswordField1.getPassword());
	}

	public String getRegisterName()
	{
		return jTextFieldNomeR.getText();
	}

	public String getRegisterPassword1()
	{
		return String.copyValueOf(jPasswordField2.getPassword());
	}

	public String getRegisterPassword2()
	{
		return String.copyValueOf(jPasswordField3.getPassword());
	}

	public void clearLoginName()
	{
		jTextFieldNomeL.setText("");
	}

	public void clearLoginPassword()
	{
		jPasswordField1.setText("");
	}

	public void clearRegisterName()
	{
		jTextFieldNomeR.setText("");
	}

	public void clearRegisterPassword1()
	{
		jPasswordField2.setText("");
	}

	public void clearRegisterPassword2()
	{
		jPasswordField3.setText("");
	}

	/**
	 * mostra uma caixa de mensagens personalizada
	 *
	 * @param message  o message a mostra na caixa
	 * @param title o ttulo da caixa
	 * @param messageType   messageType de mensagem
	 */
	public void showMessageDialog(String message, String title, int messageType)
	{
		JOptionPane.showMessageDialog(contentPane, message, title, messageType);
	}

	public void report(Exception exception)
	{
		showMessageDialog(exception.getMessage(), exception.getClass().toString(), JOptionPane.ERROR_MESSAGE);
	}
}
