package gui;

import java.io.IOException;

/**
 * @author Jorge Farinha
 * @author Tiago Santos
 * @version 1.0
 * @date 28-09-2006
 */
public interface MainInterface
{
	/**
	 * instrues a executar quando a janela principal  fechada
	 */
	public void mainWindowSair();

	/**
	 * instrues a executar quando  dado duplo clique num jogador da lista de
	 * jogadores ligados
	 *
	 * @param c o texto da linha
	 * @throws java.io.IOException no comunica com o servidor
	 */
	public void mainWindowDuploCliqueCliente(String c) throws IOException;

	/**
	 * instrues necessrias para entregar a mensagem no destino
	 *
	 * @param s a mensagem a enviar
	 */
	public void mainWindowEnviaMensagem(String s);

	/**
	 * instrues a executar quando se clica no menu ficheiro -> ligar
	 */
	public void mainWindowMenuLigar();

	/**
	 * instrues a executar quando se clica no menu ficheiro -> desligar
	 */
	public void mainWindowMenuDesligar();

	/**
	 * instrues a executar quando se clica no menu ficheiro -> sair
	 */
	public void mainWindowMenuSair();

	/**
	 * @return uma string com o nome dos autores do programa
	 */
	public String mainWindowCredits();
}
