package gui;

import javax.swing.*;
import java.awt.event.MouseListener;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Vector;

/**
 * Created by IntelliJ IDEA.
 * User: Nuno Rafael
 * Date: 26/Out/2006
 * Time: 0:15:31
 * To change this template use File | Settings | File Templates.
 */
public class MyList<T extends Comparable> extends JScrollPane
{
	private Vector<T> elements;
	private JList jList;
	private boolean ordered;

	public MyList(boolean enabled, boolean ordered)
	{
		this.ordered = ordered;
		elements = new Vector<T>();
		jList = new JList();
		setViewportView(jList);
		setEnabled(enabled);
	}

	public void clear()
	{
		elements.clear();
		refresh();
	}

	private void refresh()
	{
        if (ordered)
            Collections.sort(elements);
		jList.setListData(elements);
	}

	public void remove(T t)
	{
		elements.remove(t);
		refresh();
	}

	public void set(Vector<T> elements)
	{
		this.elements = elements;
		refresh();
	}

	public void set(Hashtable<String,T> items)
	{
		this.elements = new Vector<T>();
		for (T t : items.values())
			elements.add(t);
		refresh();
	}

	public String getSelectedValue()
	{
		return jList.getSelectedValue().toString();
	}

	public void add(T t)
	{
		elements.add(0, t);
		refresh();
	}

	public boolean isOrdered()
	{
		return ordered;
	}

	public synchronized void addMouseListener(MouseListener mouseListener)
	{
		super.addMouseListener(mouseListener);
		jList.addMouseListener(mouseListener);
	}
}
